// Anubis - King Of The Underworld

/* CVARS - copy and paste to shconfig.cfg

//Anubis
anubis_level 0
anibus_showdamage 1   //(0|1) - hide|show bullet damage..
anibus_showchat 1   //(0|1) - hide|show ghostchat messages..

*/

/*
*   v1.17 - JTP10181
* - Added ablily to disable the ghostchat like function
*   for servers that already have ghostchat
*/

#include <amxmod>
#include <Vexd_Utilities>
#include <superheromod>

// GLOBAL VARIABLES
new gHeroName[]="Anubis"
new bool:gHasAnubisPowers[SH_MAXSLOTS+1]
new gmsgSayText
new Blade, Master, Pistol, Wolverine, HobGoblin
//----------------------------------------------------------------------------------------------
public plugin_init()
{
  // Plugin Info
  register_plugin("SUPERHERO Anubis","1.17.5","AssKicR/JTP10181")

  // DO NOT EDIT THIS FILE TO CHANGE CVARS, USE THE SHCONFIG.CFG
  register_cvar("anubis_level", "0" )
  register_cvar("anibus_showdamage", "1")
  register_cvar("anibus_showchat", "1")

  // FIRE THE EVENT TO CREATE THIS SUPERHERO!
  shCreateHero(gHeroName, "Dark Notices", "Nothing Is Secret From You.  Hear Enemies - See Damage", false, "anubis_level" )

  // REGISTER EVENTS THIS HERO WILL RESPOND TO! (AND SERVER COMMANDS)
  register_event("ResetHUD","anubis_newround","b")
  register_srvcmd("anubis_init", "anubis_init")
  shRegHeroInit(gHeroName, "anubis_init")

  // Damage Event
  register_event("Damage", "damage_msg", "b", "2!0", "3=0", "4!0")

  // Say
  register_clcmd("say", "handle_say")
  register_clcmd("say_team", "handle_say")

  gmsgSayText = get_user_msgid("SayText")

}
//----------------------------------------------------------------------------------------------
public anubis_init()
{

  new temp[6]
  // First Argument is an id
  read_argv(1,temp,5)
  new id = str_to_num(temp)

  // 2nd Argument is 0 or 1 depending on whether the id has anubis
  read_argv(2,temp,5)
  new hasPowers=str_to_num(temp)

  // Got to disable anubis that lost his powers...
  if ( hasPowers )
      gHasAnubisPowers[id]=true
  else
      gHasAnubisPowers[id]=false


  if (gHasAnubisPowers[id]) anubis_speak_on(id)
  else anubis_speak_off(id)

}
//----------------------------------------------------------------------------------------------
public anubis_newround(id)
{
  if (gHasAnubisPowers[id]) anubis_speak_on(id)
  new temp[8],tempB[8],tempC[8],tempD[8],tempG[8]

  get_user_info(id,"B",temp,7)
  Blade=strtonum(temp)

  get_user_info(id,"M",tempB,7)
  Master=strtonum(tempB)

  get_user_info(id,"P",tempC,7)
  Pistol=strtonum(tempC)

  get_user_info(id,"W",tempD,7)
  Wolverine=strtonum(tempD)

  get_user_info(id,"H",tempG,7)
  HobGoblin=strtonum(tempG)
}
//----------------------------------------------------------------------------------------------
public handle_say(id)
{
  if ( !get_cvar_num("anibus_showchat") ) return

  new command[10],players[SH_MAXSLOTS]
  new message[191],name[33], player_count
  new teamname[5], sMessage[191]
  read_argv(0, command, 16)
  read_argv(1, message, 190)

  if (equal(message,"")) return
  if (equal(message,"[")) return

  new is_alive = is_user_alive(id)
  new team = get_user_team(id)
  new isSayTeam = equal(command, "say_team")
  get_user_name(id, name, 32)

  if (team == 1) copy(teamname,4,"(T)")
  else if (team == 2) copy(teamname,4,"(CT)")

  format(sMessage,190, "%c[DN]%s%s%s :  %s^n", 2,  isSayTeam ? teamname : "", is_alive ? "*ALIVE*" : "*DEAD*", name, message)
  get_players(players, player_count, "c")

  for (new i = 0; i < player_count; i++) {
    if (gHasAnubisPowers[players[i]] && is_user_connected(players[i])) {
      if (is_user_alive(players[i]) && !is_alive || isSayTeam && team != get_user_team(players[i])) {
        message_begin(MSG_ONE,gmsgSayText,{0,0,0},players[i])
        write_byte(id)
        write_string(sMessage)
        message_end()
      }
    }
  }
}
//----------------------------------------------------------------------------------------------
public anubis_speak_on(id)
{
  if (gHasAnubisPowers[id] && is_user_connected(id)) {
    SetSpeak(id, SPEAK_LISTENALL)
  }
}
//----------------------------------------------------------------------------------------------
public anubis_speak_off(id)
{
  if (!gHasAnubisPowers[id] && is_user_connected(id)) {
    SetSpeak(id, SPEAK_NORMAL)
  }
}
//----------------------------------------------------------------------------------------------
public damage_msg(id)
{
  if (!is_user_connected(id)) return

  if ( get_cvar_num("anibus_showdamage") ) {

  new damage = read_data(2)
  new weapon, bodypart, attacker = get_user_attacker(id,weapon,bodypart)
  if ( attacker <= 0 || attacker > SH_MAXSLOTS ||id <= 0 || id > SH_MAXSLOTS  || id == attacker ) return

  if (Blade || Wolverine || Pistol || Master || HobGoblin) {

  if (Master && weapon == CSW_M3) {
      new XtraDmg = floatround(damage * 1.25 - damage)
      new Dmg = floatround(damage * 1.0 + XtraDmg)
      if ( is_user_alive(attacker) && gHasAnubisPowers[attacker]) {
           set_hudmessage(0, 100, 200, -1.0, 0.56, 2, 0.1, 2.0, 0.02, 0.02, 1)
           show_hudmessage(attacker,"%i", Dmg)
           }
      if ( is_user_alive(id) && gHasAnubisPowers[id] ) {
           set_hudmessage(200, 50, 0, -1.0, 0.54, 2, 0.1, 2.0, 0.02, 0.02, 2)
           show_hudmessage(id,"%i", Dmg)
           }
       }
  else if (HobGoblin && weapon == CSW_HEGRENADE) {
      new XtraDmg = floatround(damage * 1.5 - damage)
      new Dmg = floatround(damage * 1.0 + XtraDmg)
      if ( is_user_alive(attacker) && gHasAnubisPowers[attacker]) {
           set_hudmessage(0, 100, 200, -1.0, 0.56, 2, 0.1, 2.0, 0.02, 0.02, 1)
           show_hudmessage(attacker,"%i", Dmg)
           }
      if ( is_user_alive(id) && gHasAnubisPowers[id] ) {
           set_hudmessage(200, 50, 0, -1.0, 0.54, 2, 0.1, 2.0, 0.02, 0.02, 2)
           show_hudmessage(id,"%i", Dmg)
           }
      }
  else if (Wolverine && weapon == CSW_KNIFE) {
      new XtraDmg = floatround(damage * 1.35 - damage)
      new Dmg = floatround(damage * 1.0 + XtraDmg)
      new XtraDmgA = floatround(damage * 1.85 - damage)
      new DmgA = floatround(damage * 1.0 + XtraDmgA)
      if (Blade) {
           if ( is_user_alive(attacker) && gHasAnubisPowers[attacker]) {
                set_hudmessage(0, 100, 200, -1.0, 0.56, 2, 0.1, 2.0, 0.02, 0.02, 1)
                show_hudmessage(attacker,"%i", DmgA)
           }
           if ( is_user_alive(id) && gHasAnubisPowers[id] ) {
                set_hudmessage(200, 50, 0, -1.0, 0.54, 2, 0.1, 2.0, 0.02, 0.02, 2)
                show_hudmessage(id,"%i", DmgA)
                }
            }
      else {
           if ( is_user_alive(attacker) && gHasAnubisPowers[attacker]) {
                set_hudmessage(0, 100, 200, -1.0, 0.56, 2, 0.1, 2.0, 0.02, 0.02, 1)
                show_hudmessage(attacker,"%i", Dmg)
           }
           if ( is_user_alive(id) && gHasAnubisPowers[id] ) {
                set_hudmessage(200, 50, 0, -1.0, 0.54, 2, 0.1, 2.0, 0.02, 0.02, 2)
                show_hudmessage(id,"%i", Dmg)
                }
            }
        }
  else if (Blade && weapon == CSW_KNIFE) {
            new XtraDmg = floatround(damage * 1.50 - damage)
            new Dmg = floatround(damage * 1.0 + XtraDmg)
            if ( is_user_alive(attacker) && gHasAnubisPowers[attacker]) {
                 set_hudmessage(0, 100, 200, -1.0, 0.56, 2, 0.1, 2.0, 0.02, 0.02, 1)
                 show_hudmessage(attacker,"%i", Dmg)
               }
            if ( is_user_alive(id) && gHasAnubisPowers[id] ) {
                 set_hudmessage(200, 50, 0, -1.0, 0.54, 2, 0.1, 2.0, 0.02, 0.02, 2)
                 show_hudmessage(id,"%i", Dmg)
                 }
                }
  else if (Pistol && weapon == CSW_P228 || Pistol && weapon == CSW_ELITE || Pistol && weapon == CSW_FIVESEVEN || Pistol && weapon == CSW_USP || Pistol && weapon == CSW_GLOCK18 ||  Pistol && weapon == CSW_DEAGLE || Blade &&  weapon == CSW_GLOCK18 || Blade && weapon == CSW_USP) {
              new XtraDmg = floatround(damage * 1.25 - damage)
              new Dmg = floatround(damage * 1.0 + XtraDmg)
              new XtraDmgA = floatround(damage * 1.75 - damage)
              new DmgA = floatround(damage * 1.0 + XtraDmgA)
              new XtraDmgB = floatround(damage * 1.5 - damage)
              new DmgB = floatround(damage * 1.0 + XtraDmgB)
              new temp[8]
              get_user_info(id,"D",temp,7)
              new Dracula=strtonum(temp)
              if (Pistol && Dracula && Blade && weapon == CSW_USP || Pistol && Dracula && Blade && weapon == CSW_GLOCK18) {
                      if ( is_user_alive(attacker) && gHasAnubisPowers[attacker]) {
                            set_hudmessage(0, 100, 200, -1.0, 0.56, 2, 0.1, 2.0, 0.02, 0.02, 1)
                            show_hudmessage(attacker,"%i", DmgA)
                       }
                      if ( is_user_alive(id) && gHasAnubisPowers[id] ) {
                            set_hudmessage(200, 50, 0, -1.0, 0.54, 2, 0.1, 2.0, 0.02, 0.02, 2)
                            show_hudmessage(id,"%i", DmgA)
                            }
                          }
              else if (Pistol) {
                       if ( is_user_alive(attacker) && gHasAnubisPowers[attacker]) {
                            set_hudmessage(0, 100, 200, -1.0, 0.56, 2, 0.1, 2.0, 0.02, 0.02, 1)
                            show_hudmessage(attacker,"%i", Dmg)
                       }
                       if ( is_user_alive(id) && gHasAnubisPowers[id] ) {
                            set_hudmessage(200, 50, 0, -1.0, 0.54, 2, 0.1, 2.0, 0.02, 0.02, 2)
                            show_hudmessage(id,"%i", Dmg)
                            }
                        }
              else if (Blade && Dracula && weapon == CSW_USP || Blade && Dracula && weapon == CSW_GLOCK18) {
                       if ( is_user_alive(attacker) && gHasAnubisPowers[attacker]) {
                            set_hudmessage(0, 100, 200, -1.0, 0.56, 2, 0.1, 2.0, 0.02, 0.02, 1)
                            show_hudmessage(attacker,"%i", DmgB)
                            }
                       if ( is_user_alive(id) && gHasAnubisPowers[id] ) {
                            set_hudmessage(200, 50, 0, -1.0, 0.54, 2, 0.1, 2.0, 0.02, 0.02, 2)
                            show_hudmessage(id,"%i", DmgB)
                            }
                        }
                   }
   else
  {
   if ( is_user_alive(attacker) && gHasAnubisPowers[attacker]) {
        set_hudmessage(0, 100, 200, -1.0, 0.56, 2, 0.1, 2.0, 0.02, 0.02, 1)
        show_hudmessage(attacker,"%i", damage)
      }

   if ( is_user_alive(id) && gHasAnubisPowers[id] ) {
        set_hudmessage(200, 50, 0, -1.0, 0.54, 2, 0.1, 2.0, 0.02, 0.02, 2)
        show_hudmessage(id,"%i", damage)
              }
        }
   }
  else
 {
  if ( is_user_alive(attacker) && gHasAnubisPowers[attacker]) {
      set_hudmessage(0, 100, 200, -1.0, 0.56, 2, 0.1, 2.0, 0.02, 0.02, 1)
      show_hudmessage(attacker,"%i", damage)
      }

  if ( is_user_alive(id) && gHasAnubisPowers[id] ) {
      set_hudmessage(200, 50, 0, -1.0, 0.54, 2, 0.1, 2.0, 0.02, 0.02, 2)
      show_hudmessage(id,"%i", damage)
      }
    }
  }
}