#include <amxmod>
#include <amxmisc>
#include <vexd_utilities>
#include <superheromod>

// Blade!

// CVARS
// blade_level
// Prowler - Made compaitable with Headcrab and shows hud messages for extra damage with the knife.

// VARIABLES
new gHeroName[]="Blade"
new bool:gHasBladePowers[SH_MAXSLOTS+1]
new gSpriteSmoke, gSpriteBurning
new gBurnPointsKnife
new g_isBurnedKnife[33][33]

//----------------------------------------------------------------------------------------------
public plugin_init() {
  // Plugin Info
  register_plugin("SUPERHERO Blade","1.0","TreDizzle/AssKicR")
  register_cvar("blade_level", "5" )
  shCreateHero(gHeroName, "Silver Knife/Bullets", "Burn Your Victims Alive With Your Knife or Deal Extra Burning Damage With Your USP or Glock", false, "blade_level" )

  // REGISTER EVENTS THIS HERO WILL RESPOND TO! (AND SERVER COMMANDS)
  // INIT
  register_srvcmd("blade_init", "blade_init")
  shRegHeroInit(gHeroName, "blade_init")
  register_event("ResetHUD","newRound","b")
  register_event("Damage", "blade_damage", "b", "2!0")

  // REMOTE BURN
  register_srvcmd("blade_burner", "blade_burner")

  // DEFAULT THE CVARS
  register_cvar("blade_knifespeed", "350")
  register_cvar("blade_knifemult", "1.50")
  register_cvar("blade_numburns", "10")
  register_cvar("blade_numburns2", "1")
  register_cvar("blade_pistoldamage", "1.5" )
  register_cvar("burnpointsknife", "10" )

  register_srvcmd("blade_loop", "blade_loop")
  set_task(1.0,"blade_loop",0,"",0,"b" )

  gBurnPointsKnife=get_cvar_num("burnpointsknife")

  // Let Server know about Ghost Riders max knife speed
  shSetMaxSpeed(gHeroName, "blade_knifespeed", "[29]" )
}
//----------------------------------------------------------------------------------------------
public plugin_precache() {
  gSpriteSmoke   = precache_model("sprites/steam1.spr")
  gSpriteBurning = precache_model("sprites/xfire.spr")
  precache_sound("ambience/burning1.wav")
  precache_sound("ambience/flameburst1.wav")
  precache_sound("vox/_period.wav")
  return PLUGIN_CONTINUE
}
//----------------------------------------------------------------------------------------------
public newRound(id) {
  new args[1]
  args[0]=id

  for ( new killer=1; killer<=SH_MAXSLOTS; killer++ ) {
  if (  g_isBurnedKnife[id][killer]) {
    g_isBurnedKnife[id][killer]=false
    }
  }

  gPlayerUltimateUsed[id]=false

  return PLUGIN_HANDLED
}
//----------------------------------------------------------------------------------------------
public blade_init() {

  new temp[128]
  // First Argument is an id
  read_argv(1,temp,5)
  new id=str_to_num(temp)

  // 2nd Argument is 0 or 1 depending on whether the id has thor power
  read_argv(2,temp,5)
  new hasPowers=str_to_num(temp)

  if ( hasPowers ) {
  gHasBladePowers[id]=true
  }else{
  gHasBladePowers[id]=false
  }

  if ( !hasPowers)
     {
      set_user_info(id,"B","0")
      }else{
      set_user_info(id,"B","1")
      }
  }
//----------------------------------------------------------------------------------------------
public blade_loop()
{
    for ( new id=1; id<=SH_MAXSLOTS; id++ ) {
    for ( new killer=1; killer<=SH_MAXSLOTS; killer++ ) {
      if (  g_isBurnedKnife[id][killer] && is_user_alive(id) )
      {
    shExtraDamage( id, killer, gBurnPointsKnife, "blade" )
    new korigin[3]
    get_user_origin(id,korigin)
  }
  }
  }
}
//----------------------------------------------------------------------------------------------
public blade_damage(id) {
  if (!shModActive() ) return PLUGIN_CONTINUE

  new damage = read_data(2)
  new weapon, bodypart, attacker = get_user_attacker(id, weapon, bodypart)
  new gundamage
  gundamage = floatround(damage * get_cvar_float("blade_pistoldamage") - damage)
  new knifedamage
  knifedamage = floatround(damage * get_cvar_float("blade_knifemult") - damage)
  new tempD[8]

  if ( attacker <=0 || attacker>SH_MAXSLOTS ) return PLUGIN_CONTINUE
  get_user_info(id,"A",tempD,7)
  new AntiHero=strtonum(tempD)
  if (AntiHero) return PLUGIN_CONTINUE
  //for knife
  if ( gHasBladePowers[attacker] && weapon == CSW_KNIFE && is_user_alive(id)) {
      shExtraDamage( id, attacker, knifedamage, "knife" )
      new output[8]
      get_user_info(id,"D",output,7)
      new Dracula=strtonum(output)
      if (Dracula) {
      if (damage > 50){
          burn_victim(id,attacker);
          g_isBurnedKnife[id][attacker]=true
          }
      }
  }

  //for glock
  if ( gHasBladePowers[attacker] && weapon == CSW_GLOCK18 && is_user_alive(id)) {
  new output[8]
  get_user_info(id,"D",output,7)
  new Dracula=strtonum(output)
  if (Dracula) {
  shExtraDamage( id, attacker, gundamage, "glock18" )
  burn_victim2(id,attacker)
  }
  }

  //for USP
  if ( gHasBladePowers[attacker] && weapon == CSW_USP && is_user_alive(id)) {
  new output[8]
  get_user_info(id,"D",output,7)
  new Dracula=strtonum(output)
  if (Dracula) {
  shExtraDamage( id, attacker, gundamage, "usp" )
  burn_victim2(id,attacker)
  }
  }

  return PLUGIN_CONTINUE
}
//----------------------------------------------------------------------------------------------
public burn_victim(id,killer) {
  if( Entvars_Get_Int( id, EV_INT_waterlevel ) == 3 ) return PLUGIN_CONTINUE

  emit_sound(id, CHAN_ITEM, "ambience/burning1.wav", 1.0, ATTN_NORM, 0, PITCH_NORM)

  new args[3]
  // new hp = get_user_health(id)
  args[0] = id
  args[1] = killer
  set_task(0.3,"burn_effect",451,args,3,"a", get_cvar_num("blade_numburns") )
  set_task(5.5,"stopFireSound",0,args,3)
  return PLUGIN_CONTINUE
}
//----------------------------------------------------------------------------------------------
public burn_victim2(id,killer) {
  if( Entvars_Get_Int( id, EV_INT_waterlevel ) == 3 ) return PLUGIN_CONTINUE

  emit_sound(id, CHAN_ITEM, "ambience/burning1.wav", 1.0, ATTN_NORM, 0, PITCH_NORM)

  new args[3]
  // new hp = get_user_health(id)
  args[0] = id
  args[1] = killer
  set_task(0.3,"burn_effect",451,args,3,"a", get_cvar_num("blade_numburns2") )
  set_task(5.5,"stopFireSound",0,args,3)
  return PLUGIN_CONTINUE
}
//----------------------------------------------------------------------------------------------
public burn_effect(args[]) {
  if( Entvars_Get_Int( args[0], EV_INT_waterlevel ) == 3 ) return PLUGIN_CONTINUE
  new rx,ry,rz,forigin[3]
  new id = args[0]
  rx = random_num(-30,30)
  ry = random_num(-30,30)
  rz = random_num(-30,30)
  get_user_origin(id,forigin)

    //TE_SPRITE - additive sprite, plays 1 cycle
  message_begin( MSG_BROADCAST,SVC_TEMPENTITY)
  write_byte( 17 )
  write_coord(forigin[0]+rx) // coord, coord, coord (position)
  write_coord(forigin[1]+ry)
  write_coord(forigin[2]+10+rz)
  write_short( gSpriteBurning ) // short (sprite index)
  write_byte( 30 ) // byte (scale in 0.1's)
  write_byte( 200 ) // byte (brightness)
  message_end()

      //Smoke
  message_begin( MSG_BROADCAST,SVC_TEMPENTITY)
  write_byte( 5 )
  write_coord(forigin[0]+(rx*2)) // coord, coord, coord (position)
  write_coord(forigin[1]+(ry*2))
  write_coord(forigin[2]+100+(rz*2))
  write_short( gSpriteSmoke )// short (sprite index)
  write_byte( 60 ) // byte (scale in 0.1's)
  write_byte( 15 ) // byte (framerate)
  message_end()

  return PLUGIN_CONTINUE
}
//----------------------------------------------------------------------------------------------
public client_connect(id) {
for ( new killer=1; killer<=SH_MAXSLOTS; killer++ ) {
 if (  g_isBurnedKnife[id][killer]) {
  g_isBurnedKnife[id][killer]=false
  }
 }
}
//----------------------------------------------------------------------------------------------
public client_disconnect(id) {
for ( new killer=1; killer<=SH_MAXSLOTS; killer++ ) {
 if (  g_isBurnedKnife[id][killer]) {
  g_isBurnedKnife[id][killer]=false
  }
 }
}
//----------------------------------------------------------------------------------------------
public stopFireSound(args[])
{
   new sndStop=(1<<5)
   emit_sound(args[0], CHAN_ITEM, "ambience/burning1.wav", 1.0, ATTN_NORM, sndStop, PITCH_NORM)
   return PLUGIN_CONTINUE
}
//----------------------------------------------------------------------------------------------
public blade_burner(id) {
  if (!shModActive() ) return PLUGIN_CONTINUE

  new arg[32],arg2[32]

  read_argv(1,arg,31)
  read_argv(2,arg2,31)

  new player = cmd_target(id,arg,7)
  new player2 = cmd_target(id,arg2,7)

  if (!player) return PLUGIN_HANDLED
  if (!player2) return PLUGIN_HANDLED

  new output[8]
  get_user_info(player,"D",output,7)
  new hasPowers=strtonum(output)

  if (hasPowers) {
      if ( gHasBladePowers[player2] && is_user_alive(player) ) {
        burn_victim2(player,player2)
      }
  }
  return PLUGIN_CONTINUE
}
//----------------------------------------------------------------------------------------------
