#include <amxmod>
#include <Vexd_Utilities>
#include <superheromod>

// Bomberman! - From the NES :)

// CVARS
// bomberman_level
// bomberman_xpbased -- Does he get more bombs each level           (def=0)
// bomberman_bombs   -- How Many Bombs does he start with           (def=1)
// bomberman_bpl     -- How Many More Bombs Does he get each level  (def=1)
// bomberman_radius  -- Radius of damage
// bomberman_maxdamage

//Thanks to TheLooser & Demonic_Frost for help testing

// GLOBAL VARIABLES
new gHeroName[]="Bomberman"
new bool:g_hasbombermanPower[SH_MAXSLOTS+1]
new BombEntity[33]
new BombAmmo[33]
new bombmodel[33]
new gPlayerLevels[SH_MAXSLOTS+1]
new smoke, white, fire, boom
new g_bombermanTimer[SH_MAXSLOTS+1]
//----------------------------------------------------------------------------------------------
public plugin_init()
{
  // Plugin Info
  register_plugin("SUPERHERO Bomberman","1.14.4","AssKicR")

  // DO NOT EDIT THIS FILE TO CHANGE CVARS, USE THE SHCONFIG.CFG
  register_cvar("bomberman_level", "0" )
  register_cvar("bomberman_xpbased", "1" )
  register_cvar("bomberman_bombs", "1" )
  register_cvar("bomberman_bpl", "1" )
  register_cvar("bomberman_radius", "400" )
  register_cvar("bomberman_maxdamage", "100" )

  // FIRE THE EVENT TO CREATE THIS SUPERHERO!
  shCreateHero(gHeroName, "Remote Bombs", "Press +power button to plant, and again to detonate", true, "bomberman_level" )

  // REGISTER EVENTS THIS HERO WILL RESPOND TO! (AND SERVER COMMANDS)
  register_event("ResetHUD","newRound","b")
  register_srvcmd("bomber_loop", "bomber_loop")
  set_task(1.0,"bomber_loop",0,"",0,"b")
  // KEY DOWN
  register_srvcmd("bomberman_kd", "bomberman_kd")
  shRegKeyDown(gHeroName, "bomberman_kd")

  // INIT
  register_srvcmd("bomberman_init", "bomberman_init")
  shRegHeroInit(gHeroName, "bomberman_init")

  // LEVELS
  register_srvcmd("bomberman_levels", "bomberman_levels")
  shRegLevels(gHeroName,"bomberman_levels")
}
//----------------------------------------------------------------------------------------------
public plugin_precache()
{
  precache_sound("weapons/c4_plant.wav")
  boom = precache_model("sprites/zerogxplode.spr")

  //What Skin Is The Bomb Gonna Have
  if (file_exists("models/w_bomb.mdl")) {
    precache_model("models/w_bomb.mdl")
    copy(bombmodel,32,"models/w_bomb.mdl")
  }
  else {
    precache_model("models/w_c4.mdl")
    copy(bombmodel,32,"models/w_c4.mdl")
  }
  smoke = precache_model("sprites/steam1.spr")
  white = precache_model("sprites/white.spr")
  fire = precache_model("sprites/explode1.spr")
}
//----------------------------------------------------------------------------------------------
public bomberman_init()
{
  new temp[128]
  // First Argument is an id
  read_argv(1,temp,5)
  new id=str_to_num(temp)

  // 2nd Argument is 0 or 1 depending on whether the id has Bomber man powers
  read_argv(2,temp,5)
  new hasPowers=str_to_num(temp)

  g_hasbombermanPower[id]=(hasPowers!=0)

  if (g_hasbombermanPower[id]==true) {
    newRound(id)
  }
}
//----------------------------------------------------------------------------------------------
public newRound(id)
{
  gPlayerUltimateUsed[id]=false

  if (!g_hasbombermanPower[id]) return PLUGIN_CONTINUE

  if (BombEntity[id])
  {
    RemoveEntity(BombEntity[id])
    BombEntity[id]=false
  }

  if (get_cvar_num("bomberman_xpbased")==1)
  {
    new bombs=((gPlayerLevels[id]-get_cvar_num("bomberman_level"))*get_cvar_num("bomberman_bpl")+get_cvar_num("bomberman_bombs"))
    //new bombs=((level he is - level he must be) * bombs per level) + starting bombs
    if (bombs>0) {
      BombAmmo[id] = bombs
    }
    else if (bombs==0) {
      BombAmmo[id] = 1
    }
    else {
      BombAmmo[id] = 0
    }
  }
  else {
    new bombs = get_cvar_num("bomberman_bombs")
    BombAmmo[id] = bombs
  }
  return PLUGIN_HANDLED
}
//----------------------------------------------------------------------------------------------
// RESPOND TO KEYDOWN
public bomberman_kd()
{
  new temp[6]

  if ( !hasRoundStarted() ) return PLUGIN_HANDLED

  // First Argument is an id with bomberman Powers!
  read_argv(1,temp,5)
  new id=str_to_num(temp)
  if ( !is_user_alive(id) ) return PLUGIN_HANDLED

  plant_bomb(id)
  return PLUGIN_HANDLED
}
//----------------------------------------------------------------------------------------------
public bomber_loop()
{
  for ( new id=1; id<=SH_MAXSLOTS; id++ )
  {
  if ( g_hasbombermanPower[id] && is_user_alive(id)  )
  {
    if ( g_bombermanTimer[id]>0 )
    {
    g_bombermanTimer[id]--
    new message[128]
    format(message, 127, "%d seconds until you get a new bomb", g_bombermanTimer[id] )
    set_hudmessage(50,100,255,0.05,0.65,0,1.0,4.0,0.0,0.0,6)
    show_hudmessage( id, message)
    set_user_rendering(id,kRenderFxGlowShell,0,0,0,kRenderTransAlpha,80)
    }
    else
    {
    if ( g_bombermanTimer[id] == 0 )
    {
      g_bombermanTimer[id]--
    }
    }
  }
  }
}
//----------------------------------------------------------------------------------------------
public plant_bomb(id)
{

  if (!is_user_alive(id)) return PLUGIN_HANDLED

  if (BombEntity[id] != 0)
  {
    new Float:vExplodeAt[3]
    Entvars_Get_Vector(BombEntity[id], EV_VEC_origin, vExplodeAt)

    blowUp(id, vExplodeAt)

    message_begin(MSG_BROADCAST, SVC_TEMPENTITY)
    write_byte(3)
    write_coord(floatround(vExplodeAt[0]))
    write_coord(floatround(vExplodeAt[1]))
    write_coord(floatround(vExplodeAt[2]))
    write_short(boom)
    write_byte(50)
    write_byte(15)
    write_byte(0)
    message_end()

    RemoveEntity(BombEntity[id])
    BombEntity[id] = false
    if (BombAmmo[id]>0){
        g_bombermanTimer[id]=(7+1)
      }
    return PLUGIN_CONTINUE
  }
  else if (BombEntity[id] == 0) {
    if (BombAmmo[id] == 0)
    {
      client_print(id,print_center,"You have 0 bombs left")
      return PLUGIN_HANDLED
    }

    if (g_bombermanTimer[id]>0 ) return PLUGIN_HANDLED

    BombEntity[id] = CreateEntity("info_target")
    if(BombEntity[id] == 0) return PLUGIN_HANDLED_MAIN

    Entvars_Set_String(BombEntity[id], EV_SZ_classname, "remote_bomb")
    ENT_SetModel(BombEntity[id], bombmodel)

    new Float:PlayerOrigin[3]
    Entvars_Get_Vector(id, EV_VEC_origin, PlayerOrigin)

    ENT_SetOrigin(BombEntity[id], PlayerOrigin)

    Entvars_Set_Int(BombEntity[id], EV_INT_solid, 0)
    Entvars_Set_Int(BombEntity[id], EV_INT_movetype, 6)
    Entvars_Set_Edict(BombEntity[id], EV_ENT_owner, id)

    emit_sound(BombEntity[id], CHAN_WEAPON, "weapons/c4_plant.wav", 1.0, ATTN_NORM, 0, PITCH_NORM)

    BombAmmo[id]= BombAmmo[id] - 1
    client_print(id,print_center,"Bomb Planted: You have %d bombs left",BombAmmo[id])
    }
  return PLUGIN_CONTINUE
}
//----------------------------------------------------------------------------------------------
public client_connect(id)
{
   BombEntity[id]=false
   return PLUGIN_CONTINUE
}
//----------------------------------------------------------------------------------------------
public client_disconnect(id)
{
 if (BombEntity[id])
 {
    RemoveEntity(BombEntity[id])
    BombEntity[id]=false
 }
 return PLUGIN_CONTINUE
}
//----------------------------------------------------------------------------------------------
public bomberman_levels()
{
  new id[5]
  new lev[5]

  read_argv(1,id,4)
  read_argv(2,lev,4)

  gPlayerLevels[str_to_num(id)]=str_to_num(lev)
}
//----------------------------------------------------------------------------------------------
public blowUp( id, Float:vExplodeAt[3] )
{
   new distanceBetween
   new damage, multiplier

   new name[32]
   get_user_name(id,name,31)
   set_user_rendering(id,kRenderFxNone,255,255,255, kRenderNormal,16);
   new FFOn= get_cvar_num("mp_friendlyfire")
   new origin[3]
   origin[0]=floatround(vExplodeAt[0])
   origin[1]=floatround(vExplodeAt[1])
   origin[2]=floatround(vExplodeAt[2])+37

   explode(origin) // blowup even if dead

   for(new a = 1; a <= SH_MAXSLOTS; a++)
   {
     if( is_user_alive(a) && ( get_user_team(id) != get_user_team(a) || FFOn != 0 || a == id ) ) {
       new origin1[3]
       get_user_origin(a,origin1)
       distanceBetween = get_distance(origin, origin1 )
       if( distanceBetween < get_cvar_num("bomberman_radius") ) {
         multiplier=(get_cvar_num("bomberman_maxdamage")*get_cvar_num("bomberman_maxdamage"))/get_cvar_num("bomberman_radius")
         damage=(get_cvar_num("bomberman_radius")-distanceBetween)*multiplier
         damage=sqrt(damage)
         shExtraDamage(a, id, damage, "Bomberman Bomb")
       } // distance
     } // alive target...
   } // loop
}
//----------------------------------------------------------------------------------------------
public explode( vec1[3] )
{
   // blast circles
   message_begin( MSG_BROADCAST,SVC_TEMPENTITY,vec1)
   write_byte( 21 )
   write_coord(vec1[0])
   write_coord(vec1[1])
   write_coord(vec1[2] + 16)
   write_coord(vec1[0])
   write_coord(vec1[1])
   write_coord(vec1[2] + 1936)
   write_short( white )
   write_byte( 0 ) // startframe
   write_byte( 0 ) // framerate
   write_byte( 2 ) // life 2
   write_byte( 20 ) // width 16
   write_byte( 0 ) // noise
   write_byte( 188 ) // r
   write_byte( 220 ) // g
   write_byte( 255 ) // b
   write_byte( 255 ) //brightness
   write_byte( 0 ) // speed
   message_end()

   //Explosion2
   message_begin( MSG_BROADCAST,SVC_TEMPENTITY)
   write_byte( 12 )
   write_coord(vec1[0])
   write_coord(vec1[1])
   write_coord(vec1[2])
   write_byte( 188 ) // byte (scale in 0.1's) 188
   write_byte( 10 ) // byte (framerate)
   message_end()

   //TE_Explosion
   message_begin( MSG_BROADCAST,SVC_TEMPENTITY,vec1)
   write_byte( 3 )
   write_coord(vec1[0])
   write_coord(vec1[1])
   write_coord(vec1[2])
   write_short( fire )
   write_byte( 60 ) // byte (scale in 0.1's) 188
   write_byte( 10 ) // byte (framerate)
   write_byte( 0 ) // byte flags
   message_end()


   //Smoke
   message_begin( MSG_BROADCAST,SVC_TEMPENTITY,vec1)
   write_byte( 5 ) // 5
   write_coord(vec1[0])
   write_coord(vec1[1])
   write_coord(vec1[2])
   write_short( smoke )
   write_byte( 10 )  // 2
   write_byte( 10 )  // 10
   message_end()
}
//----------------------------------------------------------------------------------------------

