#include <amxmod>
#include <superheromod>

/* Choob!
*
*
* CVARS
* choob_level        - what level must they be for Choobs powers?
* choob_health       - default 130
* choob_armor        - defualt 120
* choob_speed      - default 280
* choob_healpoints   - default 1.5
* choob_gravity      - default 0.75
*
*/
// V1.1 Now drops weapons when dropped.

// Choob V1.0 by Prowler, Credits to {HOJ} Batman/JTP10181 for borrowed code from Batman, Superman, wolverine and flash
// choob is a low level starter "jack of all trades, master of none" combining elemnts of
// Batman, superman, wolverine and flash but doing none of them paticularly well.

// GLOBAL VARIABLES
new gHeroName[]="choob"
new gHaschoPower[SH_MAXSLOTS+1]
new g_haschoobPowers[SH_MAXSLOTS+1]
new gCurrentWeapon[SH_MAXSLOTS+1]
new gmsgSetFOV
new gPlayerMaxHealth[SH_MAXSLOTS+1]
#define giveTotal 4
new weapArray[giveTotal][24] = {
  "weapon_p228",
  "weapon_scout",
  "weapon_famas",
  "weapon_galil"
 }
//----------------------------------------------------------------------------------------------
public plugin_init()
{
  // Plugin Info
  register_plugin("SUPERHERO CHOOB","1.2","Prowler")

  // DO NOT EDIT THIS FILE TO CHANGE CVARS, USE THE SHCONFIG.CFG
  register_cvar("choob_level", "1")
  register_cvar("choob_health", "130")
  register_cvar("choob_armor", "120")
  register_cvar("choob_speed", "280")
  register_cvar("choob_healpoints", "1.5" )
  register_cvar("choob_gravity", "0.50" )


  // FIRE THE EVENT TO CREATE THIS SUPERHERO!
  debugMessage("Attempting to create choob Hero")
  shCreateHero(gHeroName, "Jack of all trades", "Extra Weapons, Health, speed, heal, grav.", false, "choob_level" )

  // REGISTER EVENTS THIS HERO WILL RESPOND TO! (AND SERVER COMMANDS)
  register_srvcmd("choob_init", "choob_init")
  shRegHeroInit(gHeroName, "choob_init")
  register_event("ResetHUD","newRound","b")
  register_event("CurWeapon","changeWeapon","be","1=1")

  // Set Choobs powers
  shSetMaxHealth(gHeroName, "choob_health" )
  shSetMaxArmor(gHeroName, "choob_armor" )
  shSetMinGravity(gHeroName, "choob_gravity" )
  shSetMaxSpeed(gHeroName, "choob_speed", "[0]" )

  // HEAL LOOP
  set_task(1.0,"choob_loop",0,"",0,"b" )

  gmsgSetFOV = get_user_msgid("SetFOV")
  register_srvcmd("choob_maxhealth", "choob_maxhealth")
  shRegMaxHealth(gHeroName, "choob_maxhealth" )
}
//----------------------------------------------------------------------------------------------
public choob_init()
{
  new temp[6]
  // First Argument is an id
  read_argv(1,temp,5)
  new id=str_to_num(temp)

  // 2nd Argument is 0 or 1 depending on whether the id has choob
  read_argv(2,temp,5)
  new hasPowers = str_to_num(temp)
  gHaschoPower[id] = (hasPowers != 0)

  // Got to take away choobs powers if dropped
  if ( !hasPowers && is_user_connected(id) ) {
    shRemHealthPower(id)
    shRemSpeedPower(id)
    shRemSpeedPower(id)
    shRemArmorPower(id)
    shRemGravityPower(id)
    choob_dropweapons(id)
  }
  else {
    choob_giveweapons(id)
   }

  if ( hasPowers )
    g_haschoobPowers[id] = true
  else
    g_haschoobPowers[id] = false
}
//----------------------------------------------------------------------------------------------
public newRound(id)
{
  if ( gHaschoPower[id] && is_user_alive(id) && shModActive() ) {
    choob_giveweapons(id)
    set_user_rendering(id)
  }
  return PLUGIN_CONTINUE
}
//----------------------------------------------------------------------------------------------
public choob_giveweapons(id)
{
  if ( !is_user_alive(id) ) return

  new parm[3]
  parm[0] = id

  //Loop with tasks prevents "Reliable Channel Overflow"
  for (new x = 0; x < giveTotal; x++) {
    parm[1] = x
    set_task((0.01 * (x + 1)),"giveweap_task",0,parm,2)
  }
}
//----------------------------------------------------------------------------------------------
public giveweap_task(parm[]) {
  new id = parm[0]
  new weapname[24]
  copy (weapname,23,weapArray[parm[1]])
  shGiveWeapon(id, weapname)
}
//----------------------------------------------------------------------------------------------
public choob_loop()
{
  for ( new id = 1; id <= SH_MAXSLOTS; id++ ) {
    if (  g_haschoobPowers[id] && is_user_alive(id)  )   {
      // Let the server add the hps back since the # of max hps is controlled by it
      // I.E. Superman has more than 100 hps etc.
      shAddHPs(id, get_cvar_num("choob_healpoints"), gPlayerMaxHealth[id] )
    }
  }
}
//----------------------------------------------------------------------------------------------
public changeWeapon(id) {

    if ( !shModActive() ) return PLUGIN_CONTINUE

    new weaponid = read_data(2)

    if ( gCurrentWeapon[id] != weaponid ) {
      gCurrentWeapon[id] = weaponid
      choob_zoomout(id)
    }

    return PLUGIN_CONTINUE
}
//----------------------------------------------------------------------------------------------
public choob_dropweapons(id)
{
  if ( !is_user_alive(id) || !is_user_connected(id)) return

  new parm[3]
  parm[0] = id

  //Loop with tasks prevents "Reliable Channel Overflow"
  for (new x = 0; x < giveTotal; x++) {
    parm[1] = x
    set_task((0.001 * (x + 1)),"dropweap_task",0,parm,2)
  }
}
//----------------------------------------------------------------------------------------------
public dropweap_task(parm[]) {
  new id = parm[0]
  new weapname[24]
  new origin[3]
  get_user_origin(id,origin)
  origin[2] -= 2000
  set_user_origin(id,origin)
  copy (weapname,23,weapArray[parm[1]])
  engclient_cmd(id,"drop", weapname)
  origin[2] += 2005
  set_user_origin(id,origin)
}
//----------------------------------------------------------------------------------------------
public choob_zoomout(id) {
  if ( !is_user_connected(id) || !is_user_alive(id)) return
  message_begin(MSG_ONE, gmsgSetFOV, {0,0,0}, id)
  write_byte(90) //not Zooming
  message_end()
}
//----------------------------------------------------------------------------------------------
public choob_maxhealth()
{
  new id[6]
  new health[9]

  read_argv(1,id,5)
  read_argv(2,health,8)

  gPlayerMaxHealth[str_to_num(id)] = str_to_num(health)
}
//----------------------------------------------------------------------------------------------
