// DRACULA!

/* CVARS - copy and paste to shconfig.cfg

//Dracula
dracula_level 0
dracula_pctperlev 0.03  //What percent of damage to give back per level of player

*/

// v1.17.5 - JTP - Added code to allow you to regen to your max heatlh

#include <amxmod>
#include <superheromod>

// GLOBAL VARIABLES
new gHeroName[]="Dracula"
new bool:g_hasDraculaPowers[SH_MAXSLOTS+1]
new gPlayerLevels[SH_MAXSLOTS+1]
new gPlayerMaxHealth[SH_MAXSLOTS+1]
new Float:gMultiplier
new Headcrab
//----------------------------------------------------------------------------------------------
public plugin_init()
{
  // Plugin Info
  register_plugin("SUPERHERO Dracula","1.17.5","{HOJ} Batman/JTP10181")

  // DO NOT EDIT THIS FILE TO CHANGE CVARS, USE THE SHCONFIG.CFG
  register_cvar("dracula_level", "0" )
  register_cvar("dracula_pctperlev", "0.03" )

  // FIRE THE EVENT TO CREATE THIS SUPERHERO!
  shCreateHero(gHeroName, "Vampiric Drain", "Gain HP by shooting people - More HPs per level", false, "dracula_level" )

  // REGISTER EVENTS THIS HERO WILL RESPOND TO! (AND SERVER COMMANDS)

  // INIT
  register_srvcmd("dracula_init", "dracula_init")
  shRegHeroInit(gHeroName, "dracula_init")

  // LEVELS
  register_srvcmd("dracula_levels", "dracula_levels")
  shRegLevels(gHeroName,"dracula_levels")

  // GET MORE ENERGY!
  register_event("Damage", "dracula_damage", "b", "2!0")
  register_event("ResetHUD","newRound","b")

  //Makes superhero tell dracula a players max health
  register_srvcmd("dracula_maxhealth", "dracula_maxhealth")
  shRegMaxHealth(gHeroName, "dracula_maxhealth" )

  gMultiplier = get_cvar_float("dracula_pctperlev")
}
//----------------------------------------------------------------------------------------------
public dracula_init()
{
  // First Argument is an id
  new temp[6]
  read_argv(1,temp,5)
  new id=str_to_num(temp)

  // 2nd Argument is 0 or 1 depending on whether the id has wolverine skills
  read_argv(2,temp,5)
  new hasPowers = str_to_num(temp)

  gPlayerMaxHealth[id] = 100
  if ( hasPowers )
    g_hasDraculaPowers[id]=true
  else
    g_hasDraculaPowers[id]=false

  if ( !hasPowers)
    {
    set_user_info(id,"D","0")
    }else{
    set_user_info(id,"D","1")
  }
}
//----------------------------------------------------------------------------------------------
public newRound(id)
{
 new temp[8]
 get_user_info(id,"HC",temp,7)
 Headcrab=strtonum(temp)
}
//----------------------------------------------------------------------------------------------
public dracula_levels()
{
  new id[5]
  new lev[5]

  read_argv(1,id,4)
  read_argv(2,lev,4)

  gPlayerLevels[str_to_num(id)] = str_to_num(lev)
}
//----------------------------------------------------------------------------------------------
public dracula_damage(id)
{
  if (!shModActive()) return

  new damage = read_data(2)
  new weapon, bodypart, attacker = get_user_attacker(id,weapon,bodypart)

  if ( attacker <= 0 || attacker > SH_MAXSLOTS ||id <= 0 || id > SH_MAXSLOTS  || id == attacker ) return

  if ( g_hasDraculaPowers[attacker] && is_user_alive(attacker) && attacker != id ) {
    //Add some HP back!
    gMultiplier = get_cvar_float("dracula_pctperlev")
    new giveHPs = floatround( damage * gMultiplier * gPlayerLevels[attacker] )
    new giveOVER = floatround( damage * gMultiplier * gPlayerLevels[attacker] / 2)
    new headdrac = floatround( giveHPs * 1.25)
    new headdracOVER = floatround( giveOVER * 1.10)
    if (giveOVER > 50) giveOVER = 50
    if (get_user_health(attacker) < gPlayerMaxHealth[attacker] && giveHPs > 0 ) {
        shAddHPs(attacker, giveHPs, gPlayerMaxHealth[attacker] )
        hudmsg(attacker,giveHPs,bodypart,headdrac)
     }
    else if (get_user_health(attacker) >= gPlayerMaxHealth[attacker] && giveHPs > 0 ) {
        shAddHPs(attacker, giveOVER, 1000)
        hudmsg(attacker,giveOVER,bodypart,headdracOVER)
     }
  }
}
//----------------------------------------------------------------------------------------------
 public hudmsg(attacker,DRACHP,bodypart,DRACHEADHP) {
    if (Headcrab && bodypart==HIT_HEAD && is_user_alive(attacker) && g_hasDraculaPowers[attacker])
         {
          if (get_user_health(attacker) < gPlayerMaxHealth[attacker]){
              set_hudmessage(200, 50, 0, -1.0, 0.58, 2, 0.1, 2.0, 0.02, 0.02, 3)
              show_hudmessage(attacker,"++%iHP",DRACHEADHP)
          }
          else if (get_user_health(attacker)>= gPlayerMaxHealth[attacker]){
                  set_hudmessage(200, 50, 0, -1.0, 0.58, 2, 0.1, 2.0, 0.02, 0.02, 3)
                  show_hudmessage(attacker,"++%iHP",DRACHEADHP)
                  }
          }
    else if ( is_user_alive(attacker) && g_hasDraculaPowers[attacker])
         {
          if ( get_user_health(attacker) < gPlayerMaxHealth[attacker]){
              set_hudmessage(200, 50, 0, -1.0, 0.58, 2, 0.1, 2.0, 0.02, 0.02, 3)
              show_hudmessage(attacker,"+%iHP",DRACHP)
              }
          else if ( get_user_health(attacker) >= gPlayerMaxHealth[attacker]){
                  set_hudmessage(200, 50, 0, -1.0, 0.58, 2, 0.1, 2.0, 0.02, 0.02, 3)
                  show_hudmessage(attacker,"+%iHP",DRACHP)
                  }
         }
}
//----------------------------------------------------------------------------------------------
public dracula_maxhealth()
{
  new id[6]
  new health[9]

  read_argv(1,id,5)
  read_argv(2,health,8)

  gPlayerMaxHealth[str_to_num(id)] = str_to_num(health)
}
//----------------------------------------------------------------------------------------------
