#include <amxmod>
#include <superheromod>

// GLOBAL VARIABLES
new gHeroName[]="Electro"
new bool:gHasElectroPower[SH_MAXSLOTS+1]
new gSpriteLightning, gmsgDamage
//****Plugin Init****-------------------------------------------------------------------
public plugin_init()
{
  // Plugin Info
  register_plugin("SUPERHERO Electro","1.0","Prowler")

  // DO NOT EDIT THIS FILE TO CHANGE CVARS, USE THE SHCONFIG.CFG
  register_cvar("electro_level", "0" )
  register_cvar("electro_radius", "300" )
  register_cvar("electro_cooldown", "30" )
  // FIRE THE EVENT TO CREATE THIS SUPERHERO!
  shCreateHero(gHeroName, "Chain Lightning", "Shock several people at once!", true, "Electro_level" )

  // REGISTER EVENTS THIS HERO WILL RESPOND TO! (AND SERVER COMMANDS)
  register_event("ResetHUD","newRound","b")

  register_srvcmd("Electro_kd", "Electro_kd")
  shRegKeyDown(gHeroName, "Electro_kd")

  // INIT
  register_srvcmd("Electro_init", "Electro_init")
  shRegHeroInit(gHeroName, "Electro_init")

  // OTHER
  gmsgDamage = get_user_msgid("Damage")
}
//****Hero Init****---------------------------------------------------------------------
public Electro_init()
{
  new temp[6]

  read_argv(1,temp,5)
  new id=str_to_num(temp)
  read_argv(2,temp,5)
  new hasPower=str_to_num(temp)

  if ( hasPower != 0 )
    gHasElectroPower[id]=true
  else
    gHasElectroPower[id]=false
}
//****KeyDown****-----------------------------------------------------------------------
public Electro_kd()
{
  new temp[6]
  read_argv(1,temp,5)
  new id = str_to_num(temp)

  if ( !is_user_alive(id) || !gHasElectroPower[id]) return PLUGIN_HANDLED
  if ( gPlayerUltimateUsed[id]) {
    playSoundDenySelect(id)
    return PLUGIN_HANDLED
  }
  ultimateTimer(id, get_cvar_float("electro_cooldown"))

  new ElectroRadius = get_cvar_num("electro_radius")
  new OriginA[3]
  new OriginB[3]
  new players[32], inum


  get_user_origin(id,OriginA)
  get_players(players,inum,"a")

  for(new i = 0 ;i < inum; ++i)
  {
    get_user_origin(players[i],OriginB)
    if(get_distance(OriginA,OriginB) < ElectroRadius)
    {
      if(!gHasElectroPower[players[i]])
      {
        Lightning(id,players[i],id,OriginB)
        LightningEffects(id,players[i])
        playSound(id)
      }
    }
  }
  return PLUGIN_HANDLED
}
//****Precache****----------------------------------------------------------------------
public plugin_precache()
{
  gSpriteLightning = precache_model("sprites/lgtning.spr")
  precache_sound("ambience/deadsignal1.wav")
  return PLUGIN_CONTINUE
}
//****New Round****---------------------------------------------------------------------
public newRound(id)
{
  gPlayerUltimateUsed[id] = false
}
//****Lightning****---------------------------------------------------------------------
public Lightning(id,tid,oid,Origin[3])
{
  new idTeam = get_user_team(oid)
  new tidTeam = get_user_team(tid)

  if(tidTeam != idTeam)
  {
  shExtraDamage(oid, tid, 50, "Electrocuted")
  message_begin(MSG_ONE, gmsgDamage, {0,0,0}, tid)
  write_byte(30) // dmg_save
  write_byte(30) // dmg_take
  write_long(1<<21) // visibleDamageBits
  write_coord(Origin[0]) // damageOrigin.x
  write_coord(Origin[1]) // damageOrigin.y
  write_coord(Origin[2]) // damageOrigin.z
  message_end()
  }
  new ElectroRadius = get_cvar_num("electro_radius")
  new OriginA[3]
  new OriginB[3]
  new players[32], inum

  get_user_origin(tid,OriginA)
  get_players(players,inum,"a")

  for(new i = 0 ;i < inum; ++i)
  {
    get_user_origin(players[i],OriginB)
    if(get_distance(OriginA,OriginB) < ElectroRadius)
    {
      if(!gHasElectroPower[players[i]])
      {
        Lightning(tid,players[i],oid,OriginB)
        LightningEffects(tid,players[i])
        playSound(tid)
      }
    }
  }
}
//****Graphic****-----------------------------------------------------------------------
public LightningEffects(id,tid)
{
  new iRed,iGreen,iBlue
  iRed = random_num(0,100)
  iGreen = random_num(0,100)
  iBlue = random_num(0,255)

  if(iRed > iBlue) iBlue = (iRed + 10)
  if(iGreen > iBlue) iBlue = (iGreen + 10)
  if(iBlue > 255) iBlue = 255

  message_begin(MSG_BROADCAST, SVC_TEMPENTITY)
  write_byte(8) //TE_BEAMENTS
  write_short(id)  // start entity
  write_short(tid)  // entity
  write_short(gSpriteLightning) // model/sprite
  write_byte(0) // starting frame
  write_byte(15)  // frame rate in 0.1's
  write_byte(10)  // life in 0.1's
  write_byte(10)  // line width in 0.1's
  write_byte(10)  // noise amplitude in 0.01's
  write_byte(iRed)  // Red
  write_byte(iGreen)  // Green
  write_byte(iBlue)  // Blue
  write_byte(190)  // brightness
  write_byte(0)  // scroll speed in 0.1's
  message_end()
}
//****Sound Start****-------------------------------------------------------------------
public playSound(id)
{
  new parm[1]
  parm[0] = id

  emit_sound(id, CHAN_AUTO, "ambience/deadsignal1.wav", 1.0, ATTN_NORM, 0, PITCH_HIGH)
  set_task(1.5,"stopSound", 0, parm, 1)
}
//****Sound Stop****--------------------------------------------------------------------
public stopSound(parm[])
{
  new sndStop=(1<<5)
  emit_sound(parm[0], CHAN_AUTO, "ambience/deadsignal1.wav", 1.0, ATTN_NORM, sndStop, PITCH_NORM)
}
//****END****---------------------------------------------------------------------------
