#include <amxmod>
#include <superheromod>
#include <Vexd_Utilities>

// GLOBAL VARIABLES
new gHeroName[]="Human Torch X"
new bool:gHasHTXPower[SH_MAXSLOTS+1]
new gIsBurning[SH_MAXSLOTS+1]
new gSpriteFire, gSpriteSmoke, gSpriteFlare1, gSpriteFlare3, gSpriteBurn
//****Plugin INIT****----------------------------------------------------------------------------------------------
public plugin_init()
{
  // Plugin Info
  register_plugin("SUPERHERO Human Torch X","1.0","Prowler")

  // DO NOT EDIT THIS FILE TO CHANGE CVARS, USE THE SHCONFIG.CFG
  register_cvar("HTX_level", "0" )
  register_cvar("HTX_cooldown", "5" )
  register_cvar("HTX_radius", "100" )
  register_cvar("HTX_numburns", "5" )
  register_cvar("HTX_burndamage", "10" )

  // FIRE THE EVENT TO CREATE THIS SUPERHERO!
  shCreateHero(gHeroName, "Short Desc", "Long Desc", true, "HTX_level" )

  // REGISTER EVENTS THIS HERO WILL RESPOND TO! (AND SERVER COMMANDS)
  register_event("ResetHUD","newRound","b")

  register_srvcmd("HTX_kd", "HTX_kd")
  shRegKeyDown(gHeroName, "HTX_kd")

  // INIT
  register_srvcmd("HTX_init", "HTX_init")
  shRegHeroInit(gHeroName, "HTX_init")
}
//****Hero INIT****----------------------------------------------------------------------------------------------
public HTX_init()
{
  new temp[6]

  // First Argument is an id
  read_argv(1,temp,5)
  new id=str_to_num(temp)
  read_argv(2,temp,5)
  new hasPower=str_to_num(temp)  // !0 = has HTX power

  if ( hasPower != 0 )
    gHasHTXPower[id]=true
  else
    gHasHTXPower[id]=false
}
//****New Round****----------------------------------------------------------------------------------------------
public newRound(id)
{
  gPlayerUltimateUsed[id] = false
}
//****KeyDown****----------------------------------------------------------------------------------------------
public HTX_kd()
{
  // First Argument is an id with HTX Powers!
  new temp[6]
  read_argv(1,temp,5)
  new id = str_to_num(temp)

  if ( !is_user_alive(id) || !gHasHTXPower[id]) return PLUGIN_HANDLED
  if ( gPlayerUltimateUsed[id]) {
    playSoundDenySelect(id)
    return PLUGIN_HANDLED
  }
  new args[2]
  args[0]=id
  set_task(0.3,"OnFire",0,args,2,"a",30)
  emit_sound(id, CHAN_WEAPON, "ambience/flameburst1.wav", 1.0, ATTN_NORM, 0, PITCH_NORM)
  ultimateTimer(id, get_cvar_float("HTX_cooldown")+9.0)
  return PLUGIN_HANDLED
}
//----------------------------------------------------------------------------------------------
public burn_victim(id,killer)
{
  if( Entvars_Get_Int( id, EV_INT_waterlevel ) == 3 ) return
  if(gIsBurning[id] == 1) return

  gIsBurning[id] = 1

  emit_sound(id, CHAN_ITEM, "ambience/burning1.wav", 1.0, ATTN_NORM, 0, PITCH_NORM)

  new args[3]
  args[0] = id
  args[1] = killer
  set_task(0.3,"BurnVictim",0,args,3,"a",get_cvar_num("HTX_numburns"))
  set_task(0.7,"fire_scream",0,args,3)
  set_task(5.5,"stopFireSound",0,args,3)
}
//****On Fire****----------------------------------------------------------------------------------------------
public OnFire(args[])
{
    new id = args[0]
    new vec[3]
    new iVec[3]
    get_user_origin(id,vec)
    new iScale = random_num(10,30)
    new iFlare = random_num(1,2)
    for (new i=1; i <= SH_MAXSLOTS; i++) {
        if( is_user_alive(i) && i != id && gIsBurning[id] == 0 &&!gHasHTXPower[i] &&( get_cvar_num("mp_friendly_fire") || get_user_team(id) != get_user_team(i) ) ) {
          get_user_origin(i,iVec)
          if(get_distance(vec,iVec) < get_cvar_num("HTX_radius")) {
            burn_victim(i,id)
          }
       }
    }
    message_begin( MSG_BROADCAST,SVC_TEMPENTITY)
    write_byte(17) //TE_SPRITE additive sprite, plays 1 cycle - HLSDK const.h
    write_coord(vec[0]) // coord, coord, coord (position)
    write_coord(vec[1])
    write_coord(vec[2])
    write_short(gSpriteFire) // short (sprite index)
    write_byte(iScale) // byte (scale in 0.1's)
    write_byte(100) // byte (brightness)
    message_end()

    message_begin( MSG_BROADCAST,SVC_TEMPENTITY)
    write_byte(17) //TE_SPRITE additive sprite, plays 1 cycle - HLSDK const.h
    write_coord(vec[0]) // coord, coord, coord (position)
    write_coord(vec[1])
    write_coord(vec[2])
    write_short(gSpriteFire) // short (sprite index)
    write_byte(iScale) // byte (scale in 0.1's)
    write_byte(100) // byte (brightness)
    message_end()

    message_begin(MSG_BROADCAST,SVC_TEMPENTITY)
    write_byte(5) //TE_SMOKE - HLSDK const.h
    write_coord(vec[0]) //origin
    write_coord(vec[1])
    write_coord(vec[2])
    write_short(gSpriteSmoke)// short (sprite index)
    write_byte(iScale/2) // byte (scale in 0.1's)
    write_byte(15) // byte (framerate)
    message_end()

    message_begin(MSG_BROADCAST,SVC_TEMPENTITY)
    write_byte(15) //TE_SPRITETRAIL line of moving glow sprites with gravity, fadeout, and collisions - HLSDK const.h
    write_coord(vec[0]) //start
    write_coord(vec[1])
    write_coord(vec[2])
    write_coord(vec[0]+10) //end
    write_coord(vec[1]+10)
    write_coord(vec[2]+10)
    if(iFlare==1)write_short(gSpriteFlare1); else write_short(gSpriteFlare3)//sprite index
    write_byte(2) //count
    write_byte(1) //life in 0.1's
    write_byte(iScale/6) //scale in 0.1's
    write_byte(10) //velocity along vector in 10's
    write_byte(5) //randomness of velocity in 10's
    message_end()

    message_begin(MSG_BROADCAST ,SVC_TEMPENTITY) //message begin
    write_byte(27) //TE_DLIGHT
    write_coord(vec[0]) // position
    write_coord(vec[1])
    write_coord(vec[2])
    write_byte(20) // radius in 10's
    write_byte(200) //colour
    write_byte(150)
    write_byte(0)
    write_byte(10) //life in 10's
    write_byte(5) //decay rate in 10's
    message_end()

}
//****Burn Victim****---------------------------------------------------------------------------
public BurnVictim(args[])
{
    new id = args[0]
    new killer = args[1]
    new damage = get_cvar_num("HTX_burndamage")

    if (!is_user_alive(id)) return

    shExtraDamage(id, killer, damage, "Human Torch" )
    new rx,ry,rz,forigin[3]
    rx = random_num(-30,30)
    ry = random_num(-30,30)
    rz = random_num(-30,30)
    get_user_origin(id,forigin)

    //TE_SPRITE - additive sprite, plays 1 cycle
    message_begin( MSG_BROADCAST,SVC_TEMPENTITY)
    write_byte( 17 )
    write_coord(forigin[0]+rx) // coord, coord, coord (position)
    write_coord(forigin[1]+ry)
    write_coord(forigin[2]+10+rz)
    write_short( gSpriteBurn ) // short (sprite index)
    write_byte( 5 ) // byte (scale in 0.1's)
    write_byte( 100 ) // byte (brightness)
    message_end()

    //Smoke
    message_begin( MSG_BROADCAST,SVC_TEMPENTITY)
    write_byte( 5 )
    write_coord(forigin[0]+(rx*2)) // coord, coord, coord (position)
    write_coord(forigin[1]+(ry*2))
    write_coord(forigin[2]+100+(rz*2))
    write_short( gSpriteSmoke )// short (sprite index)
    write_byte( 20 ) // byte (scale in 0.1's)
    write_byte( 15 ) // byte (framerate)
    message_end()

    message_begin(MSG_BROADCAST ,SVC_TEMPENTITY) //message begin
    write_byte(27) //TE_DLIGHT
    write_coord(forigin[0]) // position
    write_coord(forigin[1])
    write_coord(forigin[2])
    write_byte(20) // radius in 10's
    write_byte(200) //colour
    write_byte(150)
    write_byte(0)
    write_byte(10) //life in 10's
    write_byte(5) //decay rate in 10's
    message_end()
}
//****Precache****------------------------------------------------------------------------------
public plugin_precache()   {
  gSpriteFire = precache_model("sprites/xffloor.spr")
  gSpriteBurn = precache_model("sprites/xfireball3.spr")
  gSpriteSmoke = precache_model("sprites/steam1.spr")
  gSpriteFlare3 = precache_model("sprites/xflare3.spr")
  gSpriteFlare1 = precache_model("sprites/xflare1.spr")
  precache_sound("ambience/flameburst1.wav")
  precache_sound("scientist/scream07.wav")
  return PLUGIN_CONTINUE
}
//----------------------------------------------------------------------------------------------
public fire_scream(args[])
{
  emit_sound(args[0], CHAN_AUTO, "scientist/scream07.wav", 0.5, ATTN_NORM, 0, PITCH_NORM)
  return PLUGIN_CONTINUE
}
//----------------------------------------------------------------------------------------------
public stopFireSound(args[])
{
  new sndStop=(1<<5)
  gIsBurning[args[0]] = 0
  emit_sound(args[0], CHAN_ITEM, "ambience/burning1.wav", 0.5, ATTN_NORM, sndStop, PITCH_NORM)
  return PLUGIN_CONTINUE
}
//---------------------------------------------------------------------------------------
