// MASTER!

/* CVARS - copy and paste to shconfig.cfg

//Master
master_level 0
master_healpoints 3     //The # of HP healed per second
master_shotspeed 375     //Speed of master with m3
master_shotmult 1.25     //Multiplier for m3 damage

*/

#include <amxmod>
#include <superheromod>

// GLOBAL VARIABLES
new gHeroName[]="Master"
new bool:g_hasMasterPowers[SH_MAXSLOTS+1]
new gPlayerMaxHealth[SH_MAXSLOTS+1]
//----------------------------------------------------------------------------------------------
public plugin_init()
{
  // Plugin Info
  register_plugin("SUPERHERO Master","1.0","Prowler")

  // DO NOT EDIT THIS FILE TO CHANGE CVARS, USE THE SHCONFIG.CFG
  register_cvar("master_level", "11" )
  register_cvar("master_healpoints", "3" )
  register_cvar("master_shotspeed", "375")
  register_cvar("master_shotmult", "1.25" )
  register_cvar("master_armor", "200")
  register_cvar("master_health", "200")

  // FIRE THE EVENT TO CREATE THIS SUPERHERO!
  shCreateHero(gHeroName, "Heal, Reflect, M3 damage", "Auto-Heal, M3 damage, M3 speed, Reflect SMG damage", false, "master_level" )

  // REGISTER EVENTS THIS HERO WILL RESPOND TO! (AND SERVER COMMANDS)
  register_srvcmd("master_init", "master_init")
  shRegHeroInit(gHeroName, "master_init")

  // HEAL LOOP
  set_task(1.0,"master_loop",0,"",0,"b" )

  // EXTRA KNIFE DAMAGE
  register_event("Damage", "master_damage", "b", "2!0")

  shSetMaxSpeed(gHeroName, "master_shotspeed", "[21]" )
  shSetMaxHealth(gHeroName, "master_health" )
  shSetMaxArmor(gHeroName, "master_armor" )
  //Makes superhero tell master a players max health
  register_srvcmd("master_maxhealth", "master_maxhealth")
  shRegMaxHealth(gHeroName, "master_maxhealth" )
}
//----------------------------------------------------------------------------------------------
public master_init()
{
  new temp[6]
  // First Argument is an id
  read_argv(1,temp,5)
  new id=str_to_num(temp)

  // 2nd Argument is 0 or 1 depending on whether the id has master skills
  read_argv(2,temp,5)
  new hasPowers = str_to_num(temp)

  gPlayerMaxHealth[id] = 100

  if ( hasPowers )
    g_hasMasterPowers[id]=true
    else
    g_hasMasterPowers[id]=false

  if ( !hasPowers)
     {
     set_user_info(id,"M","0")
     }else{
     set_user_info(id,"M","1")
   }

  // Got to slow down a Master that lost his powers...
  if ( !g_hasMasterPowers[id]  && is_user_connected(id) ) {
    shRemSpeedPower(id)
    shRemHealthPower(id)
    shRemArmorPower(id)
  }
 }
//----------------------------------------------------------------------------------------------
public master_loop()
{
  if (!shModActive()) return
  for ( new id = 1; id <= SH_MAXSLOTS; id++ ) {
    if (  g_hasMasterPowers[id] && is_user_alive(id) && get_user_health(id) > 100 )   {
      // Let the server add the hps back since the # of max hps is controlled by it
      // I.E. Superman has more than 100 hps etc.
      shAddHPs(id, get_cvar_num("master_healpoints"), gPlayerMaxHealth[id] )
     }
  }
}
//----------------------------------------------------------------------------------------------
public master_damage(id)
{
  if (!shModActive() || !is_user_alive(id)) return PLUGIN_CONTINUE

  new clip, ammo
  new wpnid = get_user_weapon(id, clip, ammo)
  if (wpnid == CSW_TMP || wpnid == CSW_MP5NAVY || wpnid == CSW_P90 || wpnid == CSW_MAC10 || wpnid == CSW_UMP45) return PLUGIN_CONTINUE

  new damage = read_data(2)
  new weapon, bodypart, attacker = get_user_attacker(id, weapon, bodypart)
  new extraDamage = floatround(damage * 1.25 - damage)
  new Mirrordam = floatround( damage * 0.15 )

  if (weapon == CSW_TMP || weapon == CSW_MP5NAVY || weapon == CSW_P90 || weapon == CSW_MAC10 || weapon == CSW_UMP45) {
      if (g_hasMasterPowers[id] && attacker != id && is_user_alive(attacker)) {
          set_user_health(attacker, get_user_health(attacker) - Mirrordam)
          set_hudmessage(0, 200, 0, 0.80, 0.80, 2, 0.1, 4.0, 0.02, 0.02, 4)
          show_hudmessage(id,"Reflected %i damage",Mirrordam)
          show_hudmessage(attacker,"Took %i reflected damage",Mirrordam)
          }
      }
  if ( attacker <= 0 || attacker > SH_MAXSLOTS ) return PLUGIN_CONTINUE

  if (weapon == CSW_M3) {
      if ( g_hasMasterPowers[attacker] && is_user_alive(id) ) {
           if (extraDamage > 0) shExtraDamage( id, attacker, extraDamage, "m3" )
          }
      }
  return PLUGIN_CONTINUE
}
//----------------------------------------------------------------------------------------------
public master_maxhealth()
{
  new id[6]
  new health[9]

  read_argv(1,id,5)
  read_argv(2,health,8)

  gPlayerMaxHealth[str_to_num(id)] = str_to_num(health)
}
//----------------------------------------------------------------------------------------------
