#include <amxmod.inc>
#include <superheromod.inc>

// Medic


// VARIABLES
new gHeroName[]="Medic"
new bool:gHasMedicPowers[SH_MAXSLOTS+1]
new g_MedicHeal[33]
new g_MedicAmount[201]
new gPlayerMaxHealth[SH_MAXSLOTS+1]
//----------------------------------------------------------------------------------------------
public plugin_init()
{
  // Plugin Info
  register_plugin("SUPERHERO MEDIC","4","Prowler/scoutPractice")

  // FIRE THE EVENT TO CREATE THIS SUPERHERO!
  if ( isDebugOn() ) server_print("Attempting to create Medic Hero")
  register_cvar("medic_level", "3" )
  shCreateHero(gHeroName, "Heal Teammates and Self", "Autoheal + Heal Allies on keydown", true, "medic_level" )

  // REGISTER EVENTS THIS HERO WILL RESPOND TO! (AND SERVER COMMANDS)
  // INIT
  register_srvcmd("medic_init", "medic_init")
  shRegHeroInit(gHeroName, "medic_init")
  // KEY DOWN
  register_srvcmd("medic_kd", "medic_kd")
  shRegKeyDown(gHeroName, "medic_kd")
  register_srvcmd("medic_ku", "medic_ku")
  shRegKeyUp(gHeroName, "medic_ku")

  // HEAL LOOP
  register_srvcmd("medic_loop", "medic_loop")
  register_srvcmd("medic_heal", "medic_heal")
  register_srvcmd("medic_regen", "medic_regen")
  register_srvcmd("medic_maxhealth", "medic_maxhealth")
  shRegMaxHealth(gHeroName, "medic_maxhealth" )

  set_task(1.0,"medic_loop",0,"",0,"b" )
  set_task(0.1,"medic_heal",0,"",0,"b" )
  set_task(0.3,"medic_regen",0,"",0,"b" )
   // REGISTER EVENTS THIS HERO WILL RESPOND TO! (AND SERVER COMMANDS)
  register_event("ResetHUD","newRound","b")

  // DEFAULT THE CVARS
  register_cvar("medic_healpoints", "3" )
  register_cvar("medic_specialheal", "2")
  register_cvar("medic_healradius", "50")
}
//----------------------------------------------------------------------------------------------
public medic_init()
{
  new temp[6]
  // First Argument is an id
  read_argv(1,temp,5)
  new id=str_to_num(temp)

  // 2nd Argument is 0 or 1 depending on whether the id has medic skills
  read_argv(2,temp,5)
  new hasPowers=str_to_num(temp)

  if ( hasPowers )
    gHasMedicPowers[id]=true
  else
    gHasMedicPowers[id]=false
}
//----------------------------------------------------------------------------------------------
public newRound(id)
{
 g_MedicAmount[id]=100
}
//---------------------------------------------------------------------------------------------
public medic_kd()
{
  new temp[6]

  read_argv(1,temp,5)
  new id=str_to_num(temp)
  if ( !is_user_alive(id) ) return PLUGIN_HANDLED
  g_MedicHeal[id]=1

  return PLUGIN_HANDLED
}
//---------------------------------------------------------------------------------------------
public medic_ku()
{
  new temp[6]
  read_argv(1,temp,5)
  new id = str_to_num(temp)
  g_MedicHeal[id] = 0
  }
//---------------------------------------------------------------------------------------------
public medic_heal()
{
  if (!shModActive()) return

  for ( new id=1; id<=SH_MAXSLOTS; id++ )
  {
  if (is_user_alive(id) && gHasMedicPowers[id] && g_MedicHeal[id] > 0 && g_MedicAmount[id] > 0) {
    set_hudmessage(0, 200, 0, 0.80, 0.80, 2, 0.1, 4.0, 0.02, 0.02, 4)
    new healRadius=get_cvar_num("medic_healradius")
    new specialHeal=get_cvar_num("medic_specialheal")
    new location[3], allyOrigin[3], distanceBetween
    get_user_origin(id, location)
    for ( new x=1; x<=SH_MAXSLOTS; x++)  {
      if ( (is_user_alive(x) && get_user_team(id)==get_user_team(x) && x!=id ))  {
        get_user_origin(x, allyOrigin)
        distanceBetween=get_distance(location, allyOrigin)
        if (distanceBetween < healRadius) {
            shAddHPs(x, specialHeal, 200)
            if (get_user_health(x) < 200)
            {
            g_MedicAmount[id] -= specialHeal
            show_hudmessage(id,"You Have %i HealPoints",g_MedicAmount[id])
            show_hudmessage(x,"You Are Being Healed")
            }//HudMessage
          }//HealUser
        }//Check team and is user in range
      }//Find all Users
    }//Medic Heal Init
  }//Medic ID
}//Medic heal loop
//----------------------------------------------------------------------------------------------
public medic_regen()
{
 for ( new id = 1; id <= SH_MAXSLOTS; id++ ) {
     if ( gHasMedicPowers[id] && is_user_alive(id)  )  {
       if ( g_MedicHeal[id]==0 && g_MedicAmount[id] < 100) {
         g_MedicAmount[id]++
         if (g_MedicAmount[id] == 50 || g_MedicAmount[id] == 100)
          {
          set_hudmessage(0, 200, 0, 0.80, 0.80, 2, 0.1, 4.0, 0.02, 0.02, 4)
          show_hudmessage(id,"You Have %i HealPoints",g_MedicAmount[id])
          }
        }
      }
    }
  }
//----------------------------------------------------------------------------------------------
public medic_loop()
{
  for ( new id=1; id<=SH_MAXSLOTS; id++ )
  {
    if ( gHasMedicPowers[id] && is_user_alive(id)  )
    {
      new gHealPoints=get_cvar_num("medic_healpoints")
      new gExtendedHeal=floatround(gHealPoints * 1.0 /2)
      if (get_user_health(id) < 100)shAddHPs(id, gHealPoints, 100 ) //if under 100 heal at full speed
      else shAddHPs(id, gExtendedHeal, gPlayerMaxHealth[id] ) //if over 100 heal at half speed up to max
    }
  }
}
//----------------------------------------------------------------------------------------------
public medic_maxhealth()
{
  new id[6]
  new health[9]

  read_argv(1,id,5)
  read_argv(2,health,8)

  gPlayerMaxHealth[str_to_num(id)] = str_to_num(health)
}
//----------------------------------------------------------------------------------------------
