#include <amxmod.inc>
#include <superheromod.inc>

// ninja!
// CVARS
// ninja_cooldown # of seconds before ninja can NoClip Again
// ninja_time # of seconds ninja has in noclip mode.
// ninja_level


// VARIABLES
new gHeroName[]="Ninja"
new bool:gHasNinjaPower[SH_MAXSLOTS+1]
new g_ninjaTimer[SH_MAXSLOTS+1]
new gNinjaMode[33]
new g_ninjaSound[]="ambience/alien_zonerator.wav"
new smoke
//----------------------------------------------------------------------------------------------
public plugin_init()
{
  // Plugin Info
  register_plugin("SUPERHERO Ninja","1.0","AssKicR")

  // FIRE THE EVENT TO CREATE THIS SUPERHERO!
  if ( isDebugOn() ) server_print("Attempting to create ninja Hero")
  if (!cvar_exists("ninja_level")) register_cvar("ninja_level", "5" )
  shCreateHero(gHeroName, "Ninja-Mode", "Faster,Less Visible", true, "ninja_level")
  register_clcmd("NinjaPower","make_fog",ADMIN_USER)
  // REGISTER EVENTS THIS HERO WILL RESPOND TO! (AND SERVER COMMANDS)
  register_event("ResetHUD","newRound","b")
  register_event("CurWeapon","changeWeapon","be","1=1")
  // KEY DOWN
  register_srvcmd("ninja_kd", "ninja_kd")
  shRegKeyDown(gHeroName, "ninja_kd")
  // INIT
  register_srvcmd("ninja_init", "ninja_init")
  shRegHeroInit(gHeroName, "ninja_init")
  // LOOP
  register_srvcmd("ninja_loop", "ninja_loop")
  //  shRegLoop1P0(gHeroName, "ninja_loop", "ac" ) // Alive ninjaHeros="ac"
  set_task(1.0,"ninja_loop",0,"",0,"b") //forever loop
  // DEATH
  register_event("DeathMsg", "ninja_death", "a")
  shSetMaxSpeed(gHeroName, "ninja_speed", "[29][23][16]" )
  // DEFAULT THE CVARS
  register_cvar("ninja_cooldown", "20" ) //CoolDown
  register_cvar("ninja_time", "15" ) // Time In NinjaMode
  register_cvar("ninja_speed", "375" ) //Speed he can run
  register_cvar("ninja_summon", "0" ) //1=yes 0=no
  register_cvar("ninja_smoke", "1" ) //1=yes 0=no
  register_cvar("ninja_ammo", "0" ) //1=always 0=Only in ninjamode
}
//----------------------------------------------------------------------------------------------
public plugin_precache()
{
   smoke = precache_model("sprites/steam1.spr")
   precache_sound(g_ninjaSound)
}
//----------------------------------------------------------------------------------------------
public ninja_init()
{
  new temp[128]
  // First Argument is an id
  read_argv(1,temp,5)
  new id=str_to_num(temp)

  // 2nd Argument is 0 or 1 depending on whether the id has iron man powers
  read_argv(2,temp,5)
  new hasPowers=str_to_num(temp)

  if ( !hasPowers )
  {
    ninja_endmode(id)
    g_ninjaTimer[id]=0
  }
  gHasNinjaPower[id]=(hasPowers!=0)
}
//----------------------------------------------------------------------------------------------
public newRound(id)
{
  if (g_ninjaTimer[id]>0) {
    ninja_endmode(id)
   }
  gPlayerUltimateUsed[id]=false
  return PLUGIN_HANDLED
}
//----------------------------------------------------------------------------------------------
// RESPOND TO KEYDOWN
public ninja_kd()
{

  new temp[6]
  // First Argument is an id with ninja Powers!
  read_argv(1,temp,5)
  new id=str_to_num(temp)

  if ( !is_user_alive(id) ) return PLUGIN_HANDLED

  // Let them know they already used their ultimate if they have
  if ( gPlayerUltimateUsed[id] )
  {
    playSoundDenySelect(id)
    return PLUGIN_HANDLED
  }
  // Make sure they're not in the middle of it already
  if ( g_ninjaTimer[id]>0 ) return PLUGIN_HANDLED
  g_ninjaTimer[id]=get_cvar_num("ninja_time")+1
  if (get_cvar_num("ninja_smoke")==1){
  make_fog(id)
  }
  if (get_cvar_num("ninja_summon")==1){
  summon_ninja(id)
  }
  gNinjaMode[id]=true
  shGiveWeapon(id,"weapon_tmp")
  switchweapon(id)
  // ninja Messsage
  new message[128]
  format(message, 127, "Entered ninja Mode" )
  set_hudmessage(200,10,10,-1.0,0.2,0,0.25,1.0,0.0,0.0,4)
  show_hudmessage(id, message)
  emit_sound(id,CHAN_STATIC, g_ninjaSound, 0.1, ATTN_NORM, 0, PITCH_LOW)
  set_user_info(id,"S","1")
  return PLUGIN_HANDLED
}
//----------------------------------------------------------------------------------------------
public stopSound(id)
{
    new SND_STOP=(1<<5)
    emit_sound(id,CHAN_STATIC, g_ninjaSound, 0.1, ATTN_NORM, SND_STOP, PITCH_LOW)
}
//----------------------------------------------------------------------------------------------
public ninja_loop()
{
  for ( new id=1; id<=SH_MAXSLOTS; id++ )
  {
    if ( gHasNinjaPower[id] && is_user_alive(id)  )
    {
      if ( g_ninjaTimer[id]>0 )
      {
        g_ninjaTimer[id]--
        new message[128]
        format(message, 127, "%d seconds left of Ninja Mode", g_ninjaTimer[id] )
        set_hudmessage(200,10,10,-1.0,0.2,0,0.25,1.0,0.0,0.0,4)
        show_hudmessage( id, message)
        set_user_rendering(id,kRenderFxPulseSlow,0,0,0,kRenderTransAlpha,60)
      }
      else
      {
        if ( g_ninjaTimer[id] == 0 )
        {
          g_ninjaTimer[id]--
          ninja_endmode(id)
          stopSound(id)
        }
      }
    }
  }
}
//----------------------------------------------------------------------------------------------
public ninja_endmode(id)
{
  stopSound(id)
  g_ninjaTimer[id]=0
  if ( gNinjaMode[id])
  {
     set_user_rendering(id,kRenderFxPulseSlow,0,0,0,kRenderTransAlpha,255)
     gNinjaMode[id]=false
     set_user_info(id,"S","0")
     ultimateTimer(id, get_cvar_num("ninja_cooldown") * 1.0)
  }
}
//----------------------------------------------------------------------------------------------
public ninja_death()
{
  new id=read_data(2)
  ninja_endmode(id)
  gPlayerUltimateUsed[id]=false
}
//----------------------------------------------------------------------------------------------
public switchtoprimary(id){
   new primary = (1<<23)
   new weapons[32], inum
   get_user_weapons(id,weapons,inum)
   for(new a = 0; a < inum; ++a){
      if ( primary & (1 << weapons[a] ) ){
         new weaponname[32]
         get_weaponname(weapons[a],weaponname,31)
         engclient_cmd(id,weaponname)
         return
      }
   }
   engclient_cmd(id,"weapon_knife")
}
//----------------------------------------------------------------------------------------------
public switchweapon(id){
   new primary = (1<<23)|(1<<16)|(1<<29)
   if ( primary & ( 1 << read_data(2) ) ) return
   else
   switchtoprimary(id)
}
//----------------------------------------------------------------------------------------------
public changeWeapon(id)
{
if ( !gHasNinjaPower[id] || !shModActive() || !gNinjaMode[id] ) return PLUGIN_CONTINUE

new clip, ammo, wpn[32]
new wpnid=get_user_weapon(id, clip, ammo)

if ( gHasNinjaPower[id] || gNinjaMode[id] || shModActive() ) {
    switchweapon(id)
    }
if ( wpnid==CSW_TMP || wpnid==CSW_USP) {
    if ( clip == 0 )
    {
     get_weaponname(wpnid,wpn,31)
     give_item(id,wpn)
     engclient_cmd(id, wpn )
     shResetSpeed(id)
  }
}
return PLUGIN_CONTINUE
}
//----------------------------------------------------------------------------------------------
public fog_this_area(origin[3]){
   message_begin( MSG_BROADCAST,SVC_TEMPENTITY,origin )
   write_byte( 5 )
   write_coord( origin[0] + random_num( -100, 100 ))
   write_coord( origin[1] + random_num( -100, 100 ))
   write_coord( origin[2] + random_num( -75, 75 ))
   write_short( smoke )
   write_byte( 60 )
   write_byte( 5 )
   message_end()
}
//----------------------------------------------------------------------------------------------

public make_fog(id){
   if (gHasNinjaPower[id]==false)
      return PLUGIN_HANDLED
   if (is_user_alive(id)!=1)
      return PLUGIN_HANDLED
   new origin[3]
   get_user_origin(id,origin)
   fog_this_area(origin)
   fog_this_area(origin)
   fog_this_area(origin)
   fog_this_area(origin)
   fog_this_area(origin)
   fog_this_area(origin)
   fog_this_area(origin)
   fog_this_area(origin)
   fog_this_area(origin)
   fog_this_area(origin)
   fog_this_area(origin)
   fog_this_area(origin)
   fog_this_area(origin)
   fog_this_area(origin)
   fog_this_area(origin)
   fog_this_area(origin)
   return PLUGIN_HANDLED
}
//----------------------------------------------------------------------------------------------
public summon_ninja(id)
{
new cmd[128]
new team[24]
get_user_team(id,team,7)

if (equal(team, "CT", 1)) {
  format(cmd, 127, "amx_monster hassassin #%i 1 @T", id)
  server_cmd(cmd)
}else{
  format(cmd, 127, "amx_monster hassassin #%i 1 @CT", id)
  server_cmd(cmd)
}
}
//----------------------------------------------------------------------------------------------
