#include <amxmod>
#include <superheromod>

// PUNISHER!

// CVARS
// pistol_level
// pistol_dropwpn

// GLOBAL VARIABLES
new gHeroName[]="Pistol"
new bool:gHasPistolPowers[SH_MAXSLOTS+1]
new g_ClipLimit[SH_MAXSLOTS+1]
new gLastAmmoCount[SH_MAXSLOTS+1]
new gLastWeapon[33]
new wCost[31]
//----------------------------------------------------------------------------------------------
public plugin_init()
{
  // Plugin Info
  register_plugin("SUPERHERO Pistol","1.2","Prowler")

  // DO NOT EDIT THIS FILE TO CHANGE CVARS, USE THE SHCONFIG.CFG
  register_cvar("pistol_level", "12" )
  register_cvar("pistol_dropwpn", "0" )
  register_cvar("pistol_limit", "3" )

  // FIRE THE EVENT TO CREATE THIS SUPERHERO!
  shCreateHero(gHeroName, "Super Pistols", "More pistol ammo Before reload and increased pistol damage", false, "pistol_level" )

  // REGISTER EVENTS THIS HERO WILL RESPOND TO! (AND SERVER COMMANDS)
  register_srvcmd("pistol_init", "pistol_init")
  shRegHeroInit(gHeroName, "pistol_init")

  register_event("Damage", "pistol_damage", "b", "2!0")
  register_event("ResetHUD","newRound","b")

  register_event("CurWeapon","changeWeapon","be","1=1")

}
//----------------------------------------------------------------------------------------------
public pistol_init()
{
  new temp[6]
  // First Argument is an id
  read_argv(1,temp,5)
  new id=str_to_num(temp)

  // 2nd Argument is 0 or 1 depending on whether the id has pistolerine skills
  read_argv(2,temp,5)
  new hasPowers=str_to_num(temp)

  if ( hasPowers ){
    gHasPistolPowers[id]=true
    wCost[22] = 300
    }
  else
    gHasPistolPowers[id]=false

  if ( !hasPowers)
      {
      set_user_info(id,"P","0")
      }else{
      set_user_info(id,"P","1")
  }
}
//----------------------------------------------------------------------------------------------
public newRound(id)
{
 g_ClipLimit[id]=get_cvar_num("pistol_limit")
}
//----------------------------------------------------------------------------------------------
public changeWeapon(id)
{
  if ( !gHasPistolPowers[id] || !shModActive() || !is_user_connected(id) || !is_user_alive(id)) return
  new clip, ammo
  new wpnid = get_user_weapon(id, clip, ammo)

  if ( wpnid==CSW_C4 || wpnid==CSW_HEGRENADE || wpnid == CSW_SMOKEGRENADE || wpnid == CSW_FLASHBANG || wpnid == CSW_KNIFE )

  if (gLastWeapon[id] != wpnid) {
        gLastWeapon[id] = wpnid
        gLastAmmoCount[id] = ammo
        return
        }
  if ( ammo < gLastAmmoCount[id] && gLastWeapon[id] == wpnid )
          {
          g_ClipLimit[id]=get_cvar_num("pistol_limit")
          }
  gLastAmmoCount[id]=ammo
  gLastWeapon[id]=wpnid

  if ( wpnid == CSW_P228 || wpnid == CSW_ELITE || wpnid == CSW_FIVESEVEN || wpnid == CSW_USP || wpnid == CSW_GLOCK18 || wpnid == CSW_DEAGLE) {
        if ((clip < getMaxClipAmmo(wpnid)/2) && ammo < getMaxClipAmmo(wpnid)) {
                       SecondaryAmmo(id)
                      }
        if (  clip == 0 )
            {
             if (g_ClipLimit[id]>0 ) {
             shReloadAmmo(id, get_cvar_num("pistol_dropwpn"))
             g_ClipLimit[id]--
             }
             else
             {
             client_cmd(0,"spk ^"fvox/ammo_depleted^"")
             client_cmd(id, "-attack")
             client_cmd(id, "+reload")
             client_cmd(id, "-reload")
             }
          }
      }
 }
//----------------------------------------------------------------------------------------------
public pistol_damage(id)
{
  if (!shModActive() || !is_user_alive(id)) return PLUGIN_CONTINUE

  new damage = read_data(2)
  new weapon, bodypart, attacker = get_user_attacker(id, weapon, bodypart)

  if ( attacker <= 0 || attacker > SH_MAXSLOTS ) return PLUGIN_CONTINUE

  if (weapon == CSW_P228 || weapon == CSW_ELITE || weapon == CSW_FIVESEVEN || weapon == CSW_USP || weapon == CSW_GLOCK18 || weapon == CSW_DEAGLE) {
    if ( gHasPistolPowers[attacker] && is_user_alive(id) ) {
      // do extra damage
      new extraDamage = floatround(damage * 2.0 - damage)
      if (extraDamage > 0) shExtraDamage( id, attacker, extraDamage, "Super Pistol")
      }
    }
  return PLUGIN_CONTINUE
  }
//----------------------------------------------------------------------------------------------
public Money(id,num) // check money
{
   new userMoney = get_user_money(id)-wCost[num]

   if (userMoney < 0)
   {
      client_print(id,print_center,"You have insufficient funds!")
      return false
   }
   set_user_money(id,userMoney)

   return true
}
//----------------------------------------------------------------------------------------------
public SecondaryAmmo(id) // give primary ammo
{
  if (!Money(id,22)) return

  new clip, ammo
  new wpnid = get_user_weapon(id, clip, ammo)
  switch (wpnid)
      {
         case CSW_USP:      give_item(id,"ammo_45acp")
         case CSW_GLOCK18:   give_item(id,"ammo_9mm")
         case CSW_DEAGLE:   give_item(id,"ammo_50ae")
         case CSW_P228:      give_item(id,"ammo_357sig")
         case CSW_ELITE:      give_item(id,"ammo_9mm")
         case CSW_FIVESEVEN:   give_item(id,"ammo_57mm")
      }
  }
//----------------------------------------------------------------------------------------------
