#include <amxmod>
#include <superheromod>

// GLOBAL VARIABLES
new gHeroName[]="WereWolf"
new bool:gHasWolfPower[SH_MAXSLOTS+1]
new gWolfTimer[SH_MAXSLOTS+1]
#define TASKID 532221
//----------------------------------------------------------------------------------------------
public plugin_init()
{
  // Plugin Info
  register_plugin("SUPERHERO WereWolf","1.0","Prowler")

  // DO NOT EDIT THIS FILE TO CHANGE CVARS, USE THE SHCONFIG.CFG
  register_cvar("Wolf_level", "0" )
  register_cvar("Wolf_showteam", "1" )
  register_cvar("Wolf_showenemy", "1" )
  register_cvar("Wolf_cooldown", "10" )
  register_cvar("Wolf_sencetime", "20" )

  // FIRE THE EVENT TO CREATE THIS SUPERHERO!
  shCreateHero(gHeroName, "Wolf Senses", "Your Enemys Scent is so strong it seems that they glow!", true, "Wolf_level" )

  // REGISTER EVENTS THIS HERO WILL RESPOND TO! (AND SERVER COMMANDS)

  // INIT

  register_srvcmd("Wolf_init", "Wolf_init")
  shRegHeroInit(gHeroName, "Wolf_init")

  register_srvcmd("Wolf_kd", "Wolf_kd")
  shRegKeyDown(gHeroName, "Wolf_kd")

  set_task(1.0,"Wolf_Timer",0,"",0,"b" )

  register_event("DeathMsg","death","a")
  }
//----------------------------------------------------------------------------------------------
public Wolf_init()
{
  // First Argument is an id
  new temp[6]
  read_argv(1,temp,5)
  new id=str_to_num(temp)
  read_argv(2,temp,5)
  new hasPowers = str_to_num(temp)
  gHasWolfPower[id] = (hasPowers != 0)
  if (gHasWolfPower[id]) {
  }
  else{
  remove_task(id+TASKID)
  }
}
//----------------------------------------------------------------------------------------------
public Wolf_kd()
{
  // First Argument is an id with Wolf Powers!
  new temp[6]
  read_argv(1,temp,5)
  new id = str_to_num(temp)

  if ( !is_user_alive(id) || !gHasWolfPower[id]) return PLUGIN_HANDLED
  if ( gPlayerUltimateUsed[id] || gWolfTimer[id] > 0) {
      playSoundDenySelect(id)
      return PLUGIN_HANDLED
  }
  set_task(0.1,"trailMoveCheck",id+TASKID,"",0,"b")
  gWolfTimer[id]=get_cvar_num("Wolf_sencetime")
  return PLUGIN_HANDLED
}
//----------------------------------------------------------------------------------------------
public removeAllMarks(id)
{
  new players[32], n

  if ( is_user_connected(id) && gHasWolfPower[id] )  {
    get_players(players, n, "a")
    for ( new p = 0; p < n; p++ ) {
      if ( players[p] == id ) continue
      removeMark(id,players[p])
    }
  }
}
//----------------------------------------------------------------------------------------------
public removeMark(id, pid)
{
  if ( !is_user_connected(id) ) return
  message_begin(MSG_ONE, SVC_TEMPENTITY, {0,0,0}, id)
  write_byte(99)
  write_short(pid)
  message_end()
}
//----------------------------------------------------------------------------------------------
public addAllMarks(id)
{
  new players[32], n
  new bool:sameTeam
  new bool:showTeam
  new bool:showEnemy

  if ( is_user_alive(id) && gHasWolfPower[id] )  {

    showTeam = ( get_cvar_num("Wolf_showteam") != 0 )
    showEnemy =( get_cvar_num("Wolf_showenemy") != 0 )

    get_players(players, n, "a")
    for ( new p = 0; p < n; p++ ) {
      new vec1[3]
      get_user_origin(players[p],vec1,0)

      if ( players[p] == id ) continue
      sameTeam = ( get_user_team(id)==get_user_team(players[p]) )

      if ( (sameTeam && showTeam) || (!sameTeam && showEnemy) )
      addMark(id,players[p],vec1)
    }
  }
}
//----------------------------------------------------------------------------------------------
public addMark(id, pid,vec1[3])
{
  if ( !is_user_alive(pid) ) return

  removeMark(id, pid)
  if ( get_user_team(pid) == 1 ) {
    make_trail(id, pid, 200, 0, 0, vec1)
  }
  if ( get_user_team(pid) == 2 ) {
    make_trail(id, pid, 0, 0, 200, vec1)
  }
}
//----------------------------------------------------------------------------------------------
public make_trail(id, markid, iRed, iGreen, iBlue, vec1[3])
{
  if ( !is_user_alive(id) ) return
  if ( id == markid ) return
  message_begin(MSG_ONE, SVC_TEMPENTITY, vec1, id)
  write_byte(27) //TE_DLIGHT  dynamic light, effect world, minor entity effect
  write_coord(vec1[0]) //initial position
  write_coord(vec1[1])
  write_coord(vec1[2])
  write_byte(20) //radius in 10's
  write_byte(iRed) //color red
  write_byte(iGreen) //color green
  write_byte(iBlue) //color blue
  write_byte(1) //life in 10's
  write_byte(5) //decay rate in 10's
  message_end()
 }
//----------------------------------------------------------------------------------------------
public trailMoveCheck(id)
{
  id -= TASKID
  //if ( !hasRoundStarted() ) return
  addAllMarks(id)    // Refresh the Marks...
}
//----------------------------------------------------------------------------------------------
public death()
{
  if (!shModActive() ) return PLUGIN_CONTINUE

  new victim_id = read_data(2)

  if ( gHasWolfPower[victim_id] ) {
  removeAllMarks(victim_id)
  }
  return PLUGIN_CONTINUE
}
//----------------------------------------------------------------------------------------------
public client_disconnect(id)
{
  // stupid check but lets see
  if ( id <=0 || id>32 ) return

  // Yeah don't want any left over residuals
  remove_task(id+TASKID)
}
//****Timer****-------------------------------------------------------------------------
public Wolf_Timer()
{
  for ( new id = 1; id <= SH_MAXSLOTS; id++ ) {
    if ( is_user_alive(id)  )  {
      if ( gWolfTimer[id] > 0 ) {
        gWolfTimer[id]--
      }
      else if ( gWolfTimer[id] == 0) {
        gWolfTimer[id]--
        remove_task(id+TASKID)
        ultimateTimer(id, get_cvar_float("Wolf_cooldown"))
      }
    }
  }
}
//----------------------------------------------------------------------------------------------
